/***************************************************************************
 *   Copyright (C) 2005 by Sean Harmer                                     *
 *   sh@rama.homelinux.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/

#include <qfile.h>

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <kfileitem.h>
#include <klocale.h>

#include "kfileaclpropsplugin.h"

static const char description[] =
    I18N_NOOP("A simple test for the ACL dialog functionality");

static const char version[] = "0.1";

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("acldlg", I18N_NOOP("acldlg"), version, description,
             KAboutData::License_GPL, "(C) %{YEAR} Sean Harmer", 0, 0, "sh@rama.homelinux.org");
    about.addAuthor( "Sean Harmer", 0, "sh@rama.homelinux.org" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;

    KCmdLineArgs* args = KCmdLineArgs::parsedArgs();
    KFileItemList items;
    for ( int i = 0; i < args->count(); i++ )
    {
        QString filename = QFile::decodeName( args->arg( i ) );
        items.append( new KFileItem( KFileItem::Unknown, KFileItem::Unknown, filename ) );
    }

    KFileACLPropsPlugin* mw = 0;
    mw = new KFileACLPropsPlugin( items, 0 );
    mw->resize( 400, 500 );

    app.setMainWidget( mw );
    mw->show();

    args->clear();

    return app.exec();
}

