/* This file is part of the KDE libraries
   Copyright (C) 2005 Olivier Goffart <ogoffart at kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include "kcolorsconfigwidget.h"
#include "kcolorsconfigtreewidget.h"
//#include "knotifyconfigactionswidget.h"
//#include "knotifyeventlist.h"
//#include "knotifyconfigelement.h"

#include <kapplication.h>
#include <kdialog.h>

struct KColorsConfigWidget::Private
{
//	KNotifyEventList *eventList;
//	KNotifyConfigActionsWidget *actionsconfig;
//	KNotifyConfigElement *currentElement;
	KColorsConfigTreeWidget *treeWidget;
};


KColorsConfigWidget::KColorsConfigWidget( QWidget * parent )
	: KVBox(parent) , d(new Private)
{
	d->treeWidget= new KColorsConfigTreeWidget(this);
	connect(d->treeWidget,SIGNAL(colorChanged(int , const KColorSettingsItem &)),this,SLOT(slotActionChanged()));
}


KColorsConfigWidget::~KColorsConfigWidget()
{
	delete d;
}


void KColorsConfigWidget::setApplication (const QString & app )
{
	//d->currentElement=0l;
	d->treeWidget->fill( app.isEmpty() ? KGlobal::mainComponent().componentName()  : app );
	//TODO
}


void KColorsConfigWidget::save( )
{
	d->treeWidget->save();
	emit changed(false);
}

KColorsConfigWidget * KColorsConfigWidget::configure( QWidget * parent, const QString & appname )
{
	KDialog *dialog=new KDialog(parent);
	KColorsConfigWidget *w=new KColorsConfigWidget(dialog);
	dialog->setMainWidget(w);
	
	connect(dialog,SIGNAL(applyClicked()),w,SLOT(save()));
	connect(dialog,SIGNAL(okClicked()),w,SLOT(save()));
	connect(w,SIGNAL(changed(bool)) , dialog , SLOT(enableButtonApply(bool)));

	w->setApplication(appname);
	dialog->show();
	return w;
}

void KColorsConfigWidget::slotActionChanged()
{
	emit changed( true ); //TODO
/*	if(d->currentElement)
	{
		d->actionsconfig->save( d->currentElement );
		d->eventList->updateCurrentItem();
	}*/
}


#include "kcolorsconfigwidget.moc"
