/*  This file is part of the KDE Libraries
 *  Copyright (C)  2006   Olivier Goffart <ogoffart @ kde.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */


#include "kcolorsettings.h"
#include "kcolorsettingsitem.h"

#include <kconfig.h>
#include <kdebug.h>

#include <QMetaEnum>

KColorSettings * KColorSettings::s_general=0L;


KColorSettings::KColorSettings(const QString& appname, QObject *parent)
	: QObject(parent) , m_appname(appname)
{
}


KColorSettings::~KColorSettings()
{
}



KColorSettingsItem KColorSettings::color( DefaultColor c )
{
	if(!s_general)
		s_general=new KColorSettings("kde");
	
	return s_general->color( s_general->metaObject()->enumerator(s_general->metaObject()->indexOfEnumerator("DefaultColor")).key(c)  );
}


#warning  FIX
KColorSettingsItem KColorSettings::color( const QString & key ) const
{
	KConfig *config= new KConfig("data", m_appname + '/' + m_appname + ".kcolorsrc" );
	KConfig *loconf= new KConfig( "kcolorsrc"  );
	KColorSettingsItem item;
	item.load(key, &KConfigGroup(loconf, m_appname) , &KConfigGroup(config, key ) );
	delete config;
	delete loconf;
	return item;
}

void KColorSettings::setColor( const QString & key, const KColorSettingsItem &item )
{
	kDebug() << m_appname << "  " <<  key << endl;
	KConfig *config= new KConfig( "kcolorsrc"  );
	{
		KConfigGroup cg(config, m_appname);
		item.save( key, &cg );
	}
	delete config;
}


#include "kcolorsettings.moc"

