/**
 *  Copyright (C) 2005 Benjamin C Meyer (ben at meyerhome dot net)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

/**
 * TEST: QString s = "x" + "y" + "z" V.S. QString s = "x"; s+= "y"; s+= "z";
 * 
 */

#include <sys/time.h>
#include <qstring.h>

#define LOOP 100000

/**
 * Read in paramaters and output a maze line by line.
 */

#define a "one"
#define b "+"
#define c "two"

int main( int /*argc*/, char /* *argv[]*/ ) {
	struct timeval tv1;
	struct timeval tv2;
		
	gettimeofday(&tv1, NULL);
  	for(int i=0; i< LOOP; i++){
		QString s = QString(a) + b + c;
	}

	gettimeofday(&tv2, NULL);
	qDebug("+  :  %d", (tv2.tv_usec-tv1.tv_usec));


	gettimeofday(&tv1, NULL);
  	for(int i=0; i< LOOP; i++){
		QString s = QLatin1String(a);
		s+= QLatin1String(b);
		s+= QLatin1String(c);
	}
	gettimeofday(&tv2, NULL);
	
	qDebug("+= :  %d", (tv2.tv_usec-tv1.tv_usec));
	return 0;
}

