/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef APPVIEW_H
#define APPVIEW_H

#include <qwidget.h>

namespace KNS {
class Entry;
}

class QTextEdit;
class AppManager;
class QLabel;

class AppView : public QWidget
{
    Q_OBJECT
  public:
    AppView( QWidget *parent, AppManager * );

  public slots:
    void showEntry( KNS::Entry * );

    void setStatusMessage( const QString & );

  signals:
    void install( KNS::Entry * );

  protected slots:
    void install();

  private:
    AppManager *mAppManager;
  
    QTextEdit *mTextView;  
    QLabel *mStatusLabel;

    KNS::Entry *mCurrentEntry;
};

#endif
