#include "mainwindow.h"

#include "version.h"

#include <kuniqueapplication.h>
#include <dcopclient.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <ksystemtray.h>

static const char description[] =
    I18N_NOOP("KDE Installer");

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("kinstaller", I18N_NOOP("KInstaller"), KINSTALL_VERSION,
      description,
      KAboutData::License_GPL, "(C) 2005 Cornelius Schumacher", 0, 0 );
    about.addAuthor( "Cornelius Schumacher", 0, "schumacher@kde.org" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions(options);
    KUniqueApplication::addCmdLineOptions();

#if 0
    if ( !KUniqueApplication::start() ) {
      fprintf(stderr, "KInstaller is already running!\n");
      exit(0);
    }
#endif
    KUniqueApplication app;

    // register ourselves as a dcop client
    app.dcopClient()->registerAs(app.name(), false);

    // see if we are starting with session management
    if (app.isRestored())
        RESTORE(MainWindow)
    else {
        MainWindow *widget = new MainWindow;

#if 0
        KSystemTray sysTray( widget );
        sysTray.setPixmap( sysTray.loadIcon( "knewstuff" ) );
        sysTray.show();
#else
        Q_UNUSED( widget );
#endif
//        widget->show();
    }

    return app.exec();
}
