/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef TESTUTILS_H
#define TESTUTILS_H

static ClipboardEntryList makeEntryList(int size)
{
    ClipboardEntryList list;

    for (int i=0; i<size; ++i)
    {
        ClipboardEntry entry;
        entry.data = QString::number(i);
        entry.isText = true; // TODO: change this to i%2 when images will be supported
        entry.isSelection = i % 2;
        entry.uuid = QUuid::createUuid();
        list.append(entry);
    }

    return list;
}

static const char tempFileName[] = "/tmp/klippertesthistory-tmp";
static const char tempFileName1[] = "/tmp/klippertesthistory-1-tmp";

static void removeTempFile()
{
    while (QFile::exists(tempFileName))
        QFile::remove(tempFileName);
    while (QFile::exists(tempFileName1))
        QFile::remove(tempFileName1);
}


#endif

