/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include "klipperservicejob.h"
#include "klipboard.h"

#include <KDebug>

KlipperServiceJob::KlipperServiceJob(const QString& destination,
                                     const QString& operation,
                                     const QMap<QString, QVariant>& parameters,
                                     QObject *parent)
    : Plasma::ServiceJob(destination, operation, parameters, parent)
{

}

void KlipperServiceJob::start()
{
    QString operation = operationName();
    bool result = false;

    kDebug() << "Job Started!" << operationName() << parameters();

    if (operation == "setCurrentEntry")
    {
        QString entryUuid = parameters().value("uuid").toString();
        if (!entryUuid.isEmpty())
        {
            Klipboard::self()->setCurrentEntry(entryUuid);
            result = true;
        }
        else
            kDebug() << "Error: invalid uuid passed";
    }

    setResult(result);
}

#include "klipperservicejob.moc"
