/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "backupwizard.h"
#include "backupwizardpages.h"

Nepomuk::BackupWizard::BackupWizard(QWidget* parent, Qt::WindowFlags flags)
    : QWizard(parent, flags)
{
    setPage( Id_IntroPage, new IntroPage(this) );
    setPage( Id_BackupOptionsPage, new BackupOptionsPage(this) );
    setPage( Id_BackupPage, new BackupPage(this) );
    setPage( Id_CheckpointPage, new CheckpointPage(this) );
    setPage( Id_RestorePage, new RestorePage(this) );
}


