/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef RESOLUTIONDIALOG_H
#define RESOLUTIONDIALOG_H

#include <KDialog>

#include <QtCore/QUrl>
#include <QtCore/QList>
#include <QtCore/QVariant>

#include <QtGui/QGroupBox>
#include <QtGui/QCheckBox>
#include <QtGui/QLabel>

namespace Soprano{
    class Model;
    class Node;
}

namespace Nepomuk {

    class ResolutionDialog : public KDialog
    {
        Q_OBJECT
    public:
        ResolutionDialog( const QUrl & uri, const QUrl & prop, QWidget* parent = 0, Qt::WFlags flags = 0);

    public slots:
        virtual void accept();
        
    private:
        QList<QCheckBox*> m_checkBoxes;
        QList<Soprano::Node> m_objectNodes;

        QUrl m_resUri;
        QUrl m_propUri;

        Soprano::Model * model;
    };

}

#endif // RESOLUTIONDIALOG_H
