/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef BACKUPSYNCSERVICE_H
#define BACKUPSYNCSERVICE_H

#include <Nepomuk/Service>

namespace Nepomuk {

    class DiffGenerator;
    class Identifier;
    class Merger;

    class SyncManager;
    class BackupManager;

    class BackupSyncService : public Service
    {
        Q_OBJECT
        Q_CLASSINFO("D-Bus Interface", "org.kde.BackupSync")
    public:
        BackupSyncService( QObject * parent = 0, const QList<QVariant>& args = QList<QVariant>() );
        ~BackupSyncService();

        Identifier * identifier() const;
        Merger * merger() const;
        DiffGenerator * diffGenerator() const;
        SyncManager * syncManager() const;
        BackupManager * backupManager() const;

    public Q_SLOTS:
        Q_SCRIPTABLE void test();

    private:
        DiffGenerator * m_diffGenerator;
        Identifier * m_identifier;
        Merger * m_merger;

        SyncManager * m_syncManager;
        BackupManager * m_backupManager;
	};

}

#endif // BACKUPSYNCSERVICE_H
