/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef RESOURCELOG_H
#define RESOURCELOG_H

#include <QtCore/QUrl>
#include <QtCore/QMultiHash>

#include <KUrl>

#include "changelog.h"
#include "changelogrecord.h"

namespace Nepomuk {

        
        class ResourceLog
        {
        public:
            KUrl uri;
            QMultiHash<KUrl, ChangeLogRecord> prop;
        };

        class ResourceLogMap : public QHash<KUrl, ResourceLog> {
        public:
            static ResourceLogMap fromChangeLogRecordList( const QList<ChangeLogRecord> & records );
            static ResourceLogMap fromChangeLog( const Nepomuk::ChangeLog& log );

            void optimize();
        };
    
}
#endif // RESOURCELOG_H
