/*
 * Copyright (c) 2010 Ivan Cukic <ivan.cukic(at)kde.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License version 2 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef TEST_ACTIVITY_MANAGER_H
#define TEST_ACTIVITY_MANAGER_H

#include <QMainWindow>
#include <kworkspace/kactivitycontroller.h>
#include <kworkspace/kactivityinfo.h>

#include "ui_TAMWindowBase.h"

class TestActivityManager : public QMainWindow, public Ui::TAMWindowBase
{
    Q_OBJECT

public:
    /**
     * Default Constructor
     */
    TestActivityManager();

    /**
     * Default Destructor
     */
    virtual ~TestActivityManager();


public Q_SLOTS:
    void activityAdded(const QString & id);
    void activityRemoved(const QString & id);
    void resourceWindowRegistered(const QString & application, uint wid, const QString & uri);
    void resourceWindowUnregistered(uint wid, const QString & uri);
    void currentActivityChanged(const QString & id);
    void activityNameChanged(const QString & id, const QString & name);
    void updateActivitiesList();

    void buttonActivityLoadDataClicked();
    void buttonListAssignedDocumentsClicked();
    void buttonListAssignedFoldersClicked();
    void buttonListAssignedResourcesClicked();

    void buttonAssignDocumentClicked();
    void buttonAssignFolderClicked();
    void buttonAssignResourceClicked();

private:
    KActivityController * m_controller;
    KActivityInfo * m_info;

};

#endif // _TEST-ACTIVITY-MANAGER_H_
