/*
   This file is part of the Nepomuk KDE project.
   Copyright (C) 2007 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 */

#ifndef _NEPOMUK_PLSAMA_RESOURCE_WIDGET_H_
#define _NEPOMUK_PLSAMA_RESOURCE_WIDGET_H_

#include <plasma/widgets/widget.h>

#include <nepomuk/nepomuk_export.h>

#include "abstractresourceguiitem.h"

namespace Nepomuk {
    class NEPOMUK_EXPORT PlasmaResourceWidget : public Plasma::Widget
    {
        Q_OBJECT

    public:
        PlasmaResourceWidget( QGraphicsItem* parent = 0, QObject* parentObject = 0 );
        virtual ~PlasmaResourceWidget();

        QUrl resource() const;

        virtual QSizeF sizeHint() const;

        void setDisplayMode( AbstractResourceGuiItem::DisplayMode mode );
        AbstractResourceGuiItem::DisplayMode displayMode() const;

    public Q_SLOTS:
        void setResource( const QUrl& url );

    protected:
        virtual void paintWidget( QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0 );

    private:
        class Private;
        Private* const d;
    };
}

#endif
