/*
 * search_widget_test.h
 *
 * Copyright (C) 2008 Adam Kidder <thekidder@gmail.com>
 */
#ifndef SEARCH_WIDGET_TEST_H
#define SEARCH_WIDGET_TEST_H


#include <kxmlguiwindow.h>

class search_widget_testView;
class QPrinter;
class KToggleAction;
class KUrl;

/**
 * This class serves as the main window for search_widget_test.  It handles the
 * menus, toolbars, and status bars.
 *
 * @short Main window class
 * @author Adam Kidder <thekidder@gmail.com>
 * @version 0.1
 */
class search_widget_test : public KXmlGuiWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    search_widget_test();

    /**
     * Default Destructor
     */
    virtual ~search_widget_test();

private:
    void setupActions();

private:
    search_widget_testView *m_view;

    QPrinter   *m_printer;
    KToggleAction *m_toolbarAction;
    KToggleAction *m_statusbarAction;
};

#endif // _SEARCH_WIDGET_TEST_H_
