/***************************************************************************
 *   Copyright (C) 2005,2006,2007 by Siraj Razick                          *
 *   siraj@kdemail.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef CIAVC_H
#define CIAVC_H

#include <plasma/applet.h>
#include <plasma/dataengine.h>
#include "ui_ciavcConfig.h"

class KDialog;
class QWebView;
class QGraphicsWidget;
class QGraphicsProxyWidget;
class QGraphicsLinearLayout;

class CiaVc : public Plasma::Applet
{
        Q_OBJECT
    public:
        CiaVc(QObject *parent, const QVariantList &args);
        
        virtual void init(void);
        void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option, const QRect &contentsRect);
        static bool revisionLessThan(const QString &s1, const QString &s2);

    public slots:
        void createConfigurationInterface(KConfigDialog *parent);

    private slots:
        void sourceAdded(const QString& source);
        void dataUpdated(const QString &source, const Plasma::DataEngine::Data &data);

    protected slots:
        void configAccepted();

    private:
        Plasma::DataEngine *m_ciavcEngine;
        Ui::ciavcConfig ui;
        QGraphicsLinearLayout *m_layout;
        QGraphicsProxyWidget *m_proxy;
        QGraphicsWidget *m_form;
        QWebView *m_browser;
        QString m_currentProject;
};

K_EXPORT_PLASMA_APPLET(ciavc, CiaVc)

#endif
