/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef EVENT_CELL_H_
#define EVENT_CELL_H_

#include "abstractcell.h"

#include <Plasma/IconWidget>

/**
 * Displays events like incoming messages, upcoming birthdays...
 */
class EventCell: public AbstractCell
{
Q_OBJECT

public:
    /**
     * Constructor
     * @param properties Contacts properties
     * @param parent Parent widget
     */
    EventCell(const QVariantMap &properties, QGraphicsWidget *parent);

    /** Destructor */
    virtual~ EventCell();

    /**
     * Reimplemented from AbstractCell
     */
    virtual void propertiesChanged(const QVariantMap &properties);

private Q_SLOTS:
    /** Open kopete to read messages */
    void readMessages();

private:
    /** Instant messaging id */
    QString m_id;

    /** Icon used for displaying new message alerts */
    Plasma::IconWidget *m_iconMessages;

    /** Icon used for displaying birthday alerts */
    Plasma::IconWidget *m_iconBirthday;
};

#endif // EVENT_CELL_H_
