#ifndef CPUFREQ_H
#define CPUFREQ_H

#include <Plasma/PopupApplet>
#include <Plasma/Svg>
#include <includes/Ui_PlasmaTools.h>
#include <QGraphicsProxyWidget>

//#include <kopenwithdialog.h>

class CpuHelper {
        int lastcpu;
        public:
                CpuHelper() {
                        lastcpu = -2;
                }
                bool notSameAsLastCpu(int curcpu) {
                        return (lastcpu==curcpu?true:false);
                }
};

namespace Ui {
	class CpuFreq;
}
class PlasmaCpufreq : public Plasma::Applet
{
    Q_OBJECT
	bool clickedyet;
    public:
        // Basic Create/Destroy
        PlasmaCpufreq(QObject *parent, const QVariantList &args);
        ~PlasmaCpufreq();

        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
        void init();
        QGraphicsWidget *graphicsWidget();
    public slots:
	void updateme(); // timeout function, called every 1s
	QList<QString> getAvailableFrequencies();
	QList<QString> getAvailableGovernors();
	int getAvailableCpus();
	QString getCurrentFrequency();
	QString getCurrentGovernor();
	// Default to zero
	int getCurrentCpu();
    public:
	int cpu;
    private:
        KIcon m_icon;
	int cpus;
	QString frequency;
	QString governor;
	QList<QString> governors;
	QList<QString> frequencies;
	QString Text;
	Ui::CpuFreq *ui;
	QGraphicsProxyWidget *uiProxy;
	void mousePressEvent(QGraphicsSceneMouseEvent *event);
	CpuHelper cpuhelper;
};


#endif

