/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
#ifndef UI_PLASMA_TOOLS_CPP
#define UI_PLASMA_TOOLS_CPP

#include "../includes/Ui_PlasmaTools.h"


#include <kiconloader.h>
#include <kstandarddirs.h>

#include <iostream>
#include <fcntl.h>
#include <stdio.h>
#include <cstdlib>


namespace plasma_tools {
	//aPid and subclass are boilerplate code to help popen read more easily
	//in the end it's all to make the function "runCommand(somecommand)" work.
	
	std::vector<aPid::aFp> aPid::files;

	aPid::aFp::aFp(FILE*_fp, aPid* _top) {
		fp = _fp;
		count = 1;
		top = _top;

	}
	aPid::aFp::aFp(const aFp& old) {
		top = old.top;
		fp = old.fp;
		count = 1;
		count += old.count;
	}
	aPid::aFp::~aFp() {
		std::vector<aFp>::iterator iter = top->files.begin(), end = top->files.end();
		bool found = false;
		for(;iter != end;iter++) 
			if( (*(iter)).fp == fp ) {
				(*(iter)).count--;
				found = true;
			}
		if(count == 0 && found == false) {
			pclose(fp);
		}
	}
	void aPid::addFile(FILE*fp) {
		bool found = false;
		std::vector<aFp>::iterator iter = files.begin(), end = files.end();
		for(;iter != end;iter++) {
			if((*(iter)).fp == fp) {
				found = true;
				(*(iter)).count++;
			}
		}
		if(found == false) {
			aFp nfp = aFp(fp, this);
			files.push_back(nfp);
		}
	}
	void aPid::remFile(FILE*fp) {
		std::vector<aFp>::iterator iter = files.begin(), end = files.end();
		for(;iter != end;iter++) {
			if((*(iter)).fp == fp) {
				(*(iter)).count--;
				if((*(iter)).count == 0)
					files.erase(iter);
				return;
			}
		}
	}
	ssize_t aPid::read() {
		char buf[10000];
		memset(buf, 0, sizeof(buf));
		if(feof(fp) == true) alive = false;
		ssize_t ret = fread(buf, sizeof(buf)-1, 1, fp);
		buffer.append(buf);
		return ret;
	}
	aPid::~aPid() {
		remFile(fp);
	}
	aPid::aPid(FILE* _fp) { 
		fp = _fp; 
		addFile(fp);
		alive = true;
	}
	aPid::aPid(const aPid &old) {
		buffer = old.buffer;
		fp = old.fp;
		addFile(fp);
		alive = old.alive;
	}
	QString runCommand(QString cmd) {
		aPid pid = aPid(popen(cmd.toLocal8Bit().data(), "r"));
		while(pid.alive)
			pid.read();
		return pid.buffer;
	}
	QString intToString(int num) {
		char *myBuff = new char[sizeof(int)*8+1];
		memset(myBuff, '\0', sizeof(int)*8); 
		QString strRetVal;
		// This should be portable..
		sprintf(myBuff, "%d", num);
		strRetVal = myBuff; 
		delete[] myBuff; 
		return(strRetVal); 
	}
}


#include "../includes/Ui_PlasmaTools.moc"
#endif
