/***************************************************************************
 *   Copyright (C) 2010 by Matthieu Gallien <matthieu_gallien@yahoo.fr>    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef CONTEXT_MENU_HEADER
#define CONTEXT_MENU_HEADER

#include "service_action.h"

#include <QMenu>
#include <QList>
#include <QVariant>
#include <QWidget>
#include <QPersistentModelIndex>

class QWidget;

namespace Plasma
{
    class DataEngine;
}

/** The Standard menu */
class ContextMenu : public QMenu
{
    Q_OBJECT

public:

    ContextMenu(const QString &menuName, const QIcon &menuIcon,
                const QList<QVariant> &menuDescription,
                const QPersistentModelIndex &modelIndex,
                Plasma::DataEngine *tasksEngine,
                Plasma::DataEngine *statusNotifierItemEngine,
                QWidget *parent);

private:
    
    void addServiceAction(const QVariantMap &actionDescription);

    Plasma::DataEngine *m_tasksEngine;
    Plasma::DataEngine *m_statusNotifierItemEngine;
    QPersistentModelIndex m_modelIndex;
};

#endif
