/*
    Copyright (C) 2009  George Kiagiadakis <kiagiadakis.george@gmail.com>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "qgstcolorbalancechannel.h"
#include <QtCore/QDebug>
#include <gst/interfaces/colorbalancechannel.h>

namespace QtGstreamer {

QGST_WRAPPER_GTYPE(QGstColorBalanceChannel, GST_TYPE_COLOR_BALANCE_CHANNEL)

QGstColorBalanceChannel::QGstColorBalanceChannel(GstColorBalanceChannel *gstColorBalanceChannel)
    : QObject(), m_colorbalancechannel(NULL)
{
    Q_ASSERT(gstColorBalanceChannel);
    m_colorbalancechannel = gstColorBalanceChannel;
    g_object_ref (m_colorbalancechannel);
}

QGstColorBalanceChannelPtr QGstColorBalanceChannel::fromGstColorBalanceChannel(GstColorBalanceChannel *gstColorBalanceChannel)
{
    return QGstColorBalanceChannelPtr(new QGstColorBalanceChannel(gstColorBalanceChannel));
}

QGstColorBalanceChannel::~QGstColorBalanceChannel()
{
    g_object_unref (m_colorbalancechannel);
}

int QGstColorBalanceChannel::min_value()
{
    return m_colorbalancechannel->min_value;
}

int QGstColorBalanceChannel::max_value()
{
    return m_colorbalancechannel->max_value;
}

QByteArray QGstColorBalanceChannel::label() const
{
    return QByteArray(m_colorbalancechannel->label);
}

}

#include "qgstcolorbalancechannel.moc"
