/*
    Copyright (C) 2009  George Kiagiadakis <kiagiadakis.george@gmail.com>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _QTGSTREAMER_QGSTCOLOR_BALANCE_CHANNEL_H
#define _QTGSTREAMER_QGSTCOLOR_BALANCE_CHANNEL_H

#include "../qgstobject.h"

namespace QtGstreamer {

class QGstColorBalanceChannel : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(QGstColorBalanceChannel)
    QGST_WRAPPER(QGstColorBalanceChannel)
public:
    static QGstColorBalanceChannelPtr fromGstColorBalanceChannel(GstColorBalanceChannel *gstColorBalanceChannel);
    virtual ~QGstColorBalanceChannel();

    int min_value();
    int max_value();
    QByteArray label() const;
    inline GstColorBalanceChannel *peekNativeObject();

protected:
    QGstColorBalanceChannel(GstColorBalanceChannel *gstColorBalanceChannel);    
    GstColorBalanceChannel *m_colorbalancechannel;
};

inline GstColorBalanceChannel *QGstColorBalanceChannel::peekNativeObject()
{
    return m_colorbalancechannel;
}

}

Q_DECLARE_METATYPE(QtGstreamer::QGstColorBalanceChannelPtr)

#endif
