/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef AUDIO_INPUT_DEVICE_H
#define AUDIO_INPUT_DEVICE_H
#include <QList>
#include <QSize>
#include "libqtgstreamer/qgstelement.h"

class AudioInputDevice;
typedef QSharedPointer<AudioInputDevice> AudioInputDevicePtr;

class AudioInputDevicePrivate;
class AudioInputDevice : public QtGstreamer::QGstElement
{
    Q_OBJECT
    Q_DISABLE_COPY(AudioInputDevice)
public:
    friend class AudioInputDevicePrivate;
    
    static AudioInputDevicePtr newDevice(const QString &driver, const QString &devicePath);
    virtual ~AudioInputDevice();

protected:
    AudioInputDevice(GstElement *element);

private:
    AudioInputDevicePrivate *const d;
};

#endif