/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef SVG_BUTTON_H
#define SVG_BUTTON_H

#include <QGraphicsWidget>
class QGraphicsSceneMouseEvent;

namespace Plasma
{
	class Svg;
}

class SvgButton : public QGraphicsWidget
{
	Q_OBJECT
public:
    SvgButton(QGraphicsWidget *parent=0);
    ~SvgButton();
    
    void setSvg(const QString &svgFilePath, const QString &svgIconElement = QString()); 
    void hideActiveImage();
    
Q_SIGNALS: 
    void clicked();
    void activated();
    
protected:
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent * event); 
    void mousePressEvent(QGraphicsSceneMouseEvent *event);
    void hoverEnterEvent(QGraphicsSceneHoverEvent *event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent *event); 

private:
    Plasma::Svg *mSvg;
    QString mSvgElementId;
    bool mOnHover;
    bool mShowActiveImage;
};
#endif