/*****************************************************************************
 *   Copyright (C) 2008 by Ben Cooksley <ben@eclipse.endoftheinternet.org>   *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 ****************************************************************************/

#include "quizfinish.h"

#include <QLabel>

QuizFinish::QuizFinish(QGraphicsWidget *parent) : Plasma::GroupBox(parent)
{ // Perform layouting
    layout = new QGraphicsGridLayout();
    layout->addItem(&title, 0, 0, 1, 2, Qt::AlignCenter);
    title.nativeWidget()->setAlignment(Qt::AlignCenter);
    layout->addItem(&score, 1, 0, 1, 2, Qt::AlignCenter);
    score.nativeWidget()->setAlignment(Qt::AlignCenter);
    layout->addItem(&name, 2, 0, 1, 2);
    layout->addItem(&submitResult, 3, 1, 1, 1);
    layout->addItem(&noSubmit, 3, 0, 1, 1);
    setLayout(layout);
    // Initialise static text
    submitResult.setText(i18n("Submit result"));
    noSubmit.setText(i18n("Skip submitting"));
    title.setText(i18n("Congratulations on completing the quiz!"));
}

#include "quizfinish.moc"
