/***********************************************************************************
* STasks
* Copyright (C) 2009 Marcin Baszczewski <marcin.baszczewski@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef WINDOWPREVIEW_H
#define WINDOWPREVIEW_H

#include <QWidget>
#include <QSize>
#include <QRect>
#include <QMouseEvent>

#include <Plasma/FrameSvg>

class WindowPreview : public QWidget
{
Q_OBJECT

public:
    WindowPreview(QSize pixmapSize, WId window, QWidget *parent);
    ~WindowPreview();

    QRect thumbnailRect();

    friend class TasksMenu;

protected:
    void paintEvent(QPaintEvent *event);
    void enterEvent(QEvent *event);
    void leaveEvent(QEvent *event);
    void mousePressEvent(QMouseEvent *event);

public slots:
    void updateTheme();

private:
        
    void highlightWindow(QWidget *);
    void unHighlightWindow(QWidget *);

    Plasma::FrameSvg *m_background;
    WId m_window;
    qreal m_opacity;
};

#endif
