/***************************************************************************
 *   Copyright (C) 2008 by Matej Svejda <mata@aw-modell.at>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PEACHY_ICON
#define PEACHY_ICON

#include <QGraphicsWidget>
#include <QPixmap>

#include <taskmanager/taskmanager.h>

class QPainter;
class QStyleOptionGraphicsItem;
class PeachyApplet;
class QRectF;
class QSizeF;
class QGraphicsSceneHoverEvent;

using TaskManager::TaskPtr;

class PeachyIcon : public QGraphicsWidget
{
	Q_OBJECT
	public:
		PeachyIcon(TaskPtr task, QGraphicsWidget* parent);
		~PeachyIcon();
		QRectF boundingRect() const;
		void paint(QPainter *p, const QStyleOptionGraphicsItem *option, QWidget *widget);
		QSizeF maximumSize() const;
		QSizeF minimumSize() const;
		qreal size() const;
		TaskPtr task() const;
		void setMaximumIconSize(qreal size);
		void hoverMoveEvent(QGraphicsSceneHoverEvent* e);
		void setScaling(qreal scaling);
	private:
		QPixmap m_icon;
		TaskPtr m_task;
		qreal m_maximumIconSize;
		qreal m_scaling;
	private slots:
		void mousePressEvent( QGraphicsSceneMouseEvent * event);
	signals:
		void gotHover(PeachyIcon* icon, qreal across);
};

#endif
