/***************************************************************************
 *   Copyright (C) 2009 by Kai Dombrowe <just89@gmx.de>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef BUTTONCONTAINER_H
#define BUTTONCONTAINER_H

// KDE
#include <Plasma/Frame>


namespace Plasma {
    class Animation;
}

class ButtonContainer : public Plasma::Frame
{
    Q_OBJECT


public:
    ButtonContainer(QGraphicsWidget *parent);
    ~ButtonContainer();
        
    void show();
    void hide();
    

public slots:
    void setSortingEnabled(const bool &enabled);
    
    
private slots:
    void hideFinished();
    

private:
    Plasma::Animation *m_fadeAnimation;
    bool m_firstShow;


protected:
    QSizeF sizeHint(Qt::SizeHint which, const QSizeF &constraint = QSizeF()) const;
      
    void mousePressEvent(QGraphicsSceneMouseEvent *event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
    void wheelEvent(QGraphicsSceneWheelEvent *event);

    
signals:
    void up();
    void down();
    void edit();
    void remove();

        
};


#endif

