#include "screenbutton.h"
#include <KIcon>
#include <QGraphicsLinearLayout>
#include "plasma/widgets/frame.h"
#include "plasma/widgets/iconwidget.h"

ScreenButton::ScreenButton(const QString &label, QGraphicsWidget *parent):
	Plasma::Frame(parent)
{
    m_label = new Plasma::IconWidget(KIcon("preferences-desktop-display-randr"), label, this);

    m_layout = new QGraphicsLinearLayout(this);
    setLayout(m_layout);

    m_layout->addItem(m_label);

    connect( m_label, SIGNAL( activated() ), parent, SLOT( disableScreenButtons() ));
    connect( m_label, SIGNAL( activated() ), this, SLOT( enable() ));
}

void ScreenButton::enable()
{
    //setPalette(QPalette::Active);
    //m_label->palette().setCurrentColorGroup(QPalette::Active);
    m_label->setTextBackgroundColor(QColor(255, 255, 255, 100));
    enabled = true;
}

void ScreenButton::disable()
{
    //setPalette(QPalette::Disabled);
    //m_label->palette().setCurrentColorGroup(QPalette::Disabled);
    m_label->setTextBackgroundColor(QColor());
    enabled = false;
}

bool ScreenButton::isEnabled()
{
    return enabled;
}

