/***************************************************************************
*   Copyright (C) 2008 by Gerhard Gappmeier   *
*   gerhard.gappmeier@ascolab.com   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef STOCKWIDGET_H
#define STOCKWIDGET_H

// We need the Plasma Applet headers
#include <KIcon>

#include <Plasma/Applet>
#include <Plasma/Svg>
#include <Plasma/DataEngine>

class StockItem;
class TrendItem;
class QGraphicsGridLayout;

// Define our plasma Applet
class StockWidget : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        StockWidget(QObject *parent, const QVariantList &args);
        ~StockWidget();

        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                            const QStyleOptionGraphicsItem *option,
                            const QRect& contentsRect);
        void init();

    public slots:
        void addStock(const QString &source, const QString &sName);
        void dataUpdated(const QString &source, Plasma::DataEngine::Data data);
        void sltNewSource(const QString &source);
        void sltSourceRemoved(const QString &source);
        
    private:
        Plasma::DataEngine  *m_pStocksEngine;
        QVector<StockItem*>  m_vecStocks;
        QVector<TrendItem*>  m_vecTrends;
        QGraphicsGridLayout *m_pGridLayout;
};

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(stockwidget, StockWidget)

#endif // STOCKWIDGET_H

