/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "timetrackerview.h"
#include <QGraphicsLinearLayout>
#include <QDateTime>

TimeTrackerView::TimeTrackerView(QGraphicsItem* parent, const QString& serviceId, uint appletId): Applet(parent, serviceId, appletId)
{
    m_jobs = new Plasma::TextBrowser(this);
    m_finishedJob = new Plasma::LineEdit(this);
    m_btnSendJobs = new Plasma::PushButton(this);
    m_btnSendJobs->setText(i18n("add"));
    
    m_wastedTime = new Plasma::Label(this);
    m_workedTime = new Plasma::Label(this);
    
    QGraphicsLinearLayout *l = new QGraphicsLinearLayout(Qt::Vertical);
    QGraphicsLinearLayout *l2 = new QGraphicsLinearLayout(Qt::Horizontal);
    QGraphicsLinearLayout *l3 = new QGraphicsLinearLayout(Qt::Horizontal);
    
    
    l2->addItem(m_finishedJob);
    l2->addItem(m_btnSendJobs);
    
    l3->addItem(m_workedTime);
    l3->addItem(m_wastedTime);
  
    l->addItem(m_jobs);
    l->addItem(l3);
    l->addItem(l2);
  
    setLayout(l);
    connect(m_btnSendJobs, SIGNAL(clicked()), this, SLOT( updateTimeStamps()));
 }

#include <ctime>

void TimeTrackerView::updateTimeStamps()
{
    qDebug() << "Updating Time Stamps";
    QString s = m_finishedJob->text();
    m_finishedJob->setText("");
    s = s.trimmed();
    if ( s.isEmpty() ) return;
    
    QDateTime date = QDateTime::currentDateTime();

    //TODO: Transformar isso em uma mini - tabela HTML pra colorizar essas paradinhas de forma melhor.
    QString text;
    text += date.date().toString();
    text += "\t";
    text += date.time().toString();
    text += "\t";
    
    if (m_jobList.size() == 0){
	t_startedAt = time(0);
    }
    
    if (s == i18n("starting")){
	saveCurrentInformation();
	m_jobList.clear();
	m_jobList.append(Jobs(time(0), s, 0));
    }else if (s.endsWith("**")){ 
      m_jobList.append(Jobs(time(0), s, Jobs::NonCountableFreeTime));
      text += s;
    }else if (s.endsWith('*')){  
      m_jobList.append(Jobs(time(0), s, Jobs::FreeTime));
      text += s;
    }else{
      m_jobList.append(Jobs(time(0), s, Jobs::Work));
      text += s;
    }
    
    m_jobs->append(text);

    if (m_jobList.size() == 1){
      t_wasted = 0;
      t_worked = 0;
    }else if (s.endsWith('*')){
      t_wasted += ( time(0) - t_startedAt );
      qDebug() << t_wasted;
    }else{
      t_worked += ( time(0) - t_startedAt );
      qDebug() << t_worked;
    }
    
    if (t_wasted != 0){
      int wastedHours = t_wasted / 3600; t_wasted -= wastedHours * 3600;
      int wastedMinutes = t_wasted / 60; t_wasted -= wastedMinutes * 60;
      int wastedSeconds = t_wasted;
      m_wastedTime->setText(QString("%1: %2:%3:%4").arg(i18n("Wasted Time:" )).arg(wastedHours).arg(wastedMinutes).arg(wastedSeconds));
    }
    
    if (t_worked != 0){
      int workedHours = t_worked / 3600; t_worked -= workedHours * 3600;
      int workedMinutes = t_worked / 60; t_worked -= workedMinutes * 60;
      int workedSeconds = t_worked;
      m_workedTime->setText(QString("%1: %2:%3:%4").arg(i18n("Worked Time:" )).arg(workedHours).arg(workedMinutes).arg(workedSeconds));
    }
}

void TimeTrackerView::saveCurrentInformation(){
  
}