=begin
# -*- coding utf-8 -*-
#/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
=end
class TipDatabase
	def open(s, a)
		begin
			return File.new("%s" % s, a)
		rescue
			puts "Couldn't open file"
			puts s
		end
	end
	def initialize(file)
		begin
			@dbfile = open(file, 'r')
		rescue IOError
			@dbfile = open(file, 'w')
			@dbfile.close()
			@dbfile = open(file, 'r')
			#Other exceptions will just raise
		end
		@tips = []
		load(@dbfile, file)
		@dbfile.close()
		@currenttip = 0
	end
	def tip()
		if(@tips[@currenttip][1] == 'HTML')
			return @tips[@currenttip][0]
		end
		return "<html>Category:%s<br><br>Did you know...<br>%2s</html>".sub("%s", @tips[@currenttip][1]).sub("%2s", @tips[@currenttip][0])
	end
	def isHtml()
		if(@tips[@currenttip][1] == 'HTML') 
			return true
		end
		return false
	end
	def prevTip()
		if(@tips.length() == 0) 
			return
		end
		@currenttip = @currenttip - 1
		if(@currenttip < 0) 
			@currenttip = @tips.length() - 1
		end
	end
	def nextTip()
		if(@tips.length() == 0)
			return
		end
		@currenttip = @currenttip +1
		if(@currenttip >= @tips.length() )
			@currenttip = 0
		end
	end
	def load(input, fname)
		@tips = []
#		begin
		puts "Fname is " + fname
		puts input
		@currenttip = 0
		if not fname['.html'] == nil
			@tips << [ 'file:'+fname , 'HTML' ]
			@currenttip = 0
			return
		end
		list = input.read().split("</tip>")
		for item in list
			if(item.length() > 6)

				category = "Unknown"
				cat = item.index("category=")
				if cat != -1
					findclose = item.index('"', cat+10)
					findend = item.index(">", findclose)
					category = item[cat+10,findclose-(cat+10)]
					rend = item.length()
					item = item[findend+1,rend-findend+1]
					item = item.sub("</tip>", "")
				else
					findend = item.index(">", 0)
					len = item.length()
					item = item[findend+1,len-findend+1]
				end
				item = item.sub("<html>","")
				item = item.sub("</html>", "")
				item = item.chomp()
				@tips << ["%s\n" % item, category]
			end
		end
                if(@tips.length() == 0)
                        @currenttip = 0
                else
                        @currenttip = rand( @tips.length() )
                end

#		rescue
#			@tips << ["Invalid Tipfile!", "Bad Tipfile"]
#		end
		
	end
end
