/*
 * Copyright (C) 2009 Sacha Schutz ( istdasklar@free.fr) 
 * USE lex newton code from qt-apps
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "google_translator.h"
#include <KDebug>
GoogleTranslator::GoogleTranslator(QObject * parent)
  : AbstractTranslator(parent)
{
setName("Google");

}
//==============================================================================
void GoogleTranslator::setTranslate(QString source, QString from, QString to)
{

    m_http = new QHttp(this);
    QString url = QString("/translate_a/t?client=t&sl=" + from + "&tl=" + to);
    kDebug("Url configured.");

    QHttpRequestHeader header = QHttpRequestHeader("POST", url, 1, 1);
    header.setValue("Host", "www.google.com");
    header.setValue("User-Agent", "Mozilla/5.0");
    header.setValue("Accept-Encoding", "deflate");
    header.setContentLength(source.length());
    header.setValue("Connection", "Close");
    kDebug("Headers configured.");

    QByteArray ba("text=");
    ba.append( source.toUtf8() );
    kDebug("ByteArray completed.");

    m_http->setHost("www.google.com");
    kDebug("HTTP host setted");

    m_http->request(header,ba);
    kDebug("Request started");

    connect(m_http, SIGNAL(done(bool)), this, SLOT(done()));

}
//=============================================================================
void GoogleTranslator::done()
{

kDebug("HTTP Request done.");

    QString text;
    text = text.fromUtf8( m_http->readAll() );
    kDebug("All data is readed.");

    text = text.replace(QString("\\\""),QString("\""));
    text = text.replace(QString("\\n"),QString("\n"));
    text = text.replace(QString("\n "),QString("\n"));
    text = text.replace(QString("\\x3c"),QString("<"));
    text = text.replace(QString("\\x3e"),QString(">"));

    if ( text.startsWith( QString("\"") ) ) {
        kDebug("This is a text.");
        text = text.remove( text.length()-1, 1).remove(0,1);
    } else if ( text.startsWith( QString("[") ) && text.endsWith( QString("]") ) ) {
        kDebug("This is a word.");
        QStringList tra;
        tra = text.split(QRegExp(QString("\"(.*)\"")));
        text = text.replace(QString("]"),QString(""));
        tra = text.split(QString("["));
        text = QString("");
        for (int i=0,j=0;i<tra.count();i++)
        {
            if (tra.at(i)!="")
            {
                if (j==0)
                {
                    QString translation = tra.at(i);
                    translation = translation.replace("\"","");
                    translation = translation.replace(",","");
                    text.append( translation );
                    text.append( "\n\n") ;
                } else {
                    QString translation = tra.at(i);
                    QStringList translations = translation.split(",");
                    for (int y=0;y<translations.count();y++)
                    {
                        translation = translations.at(y);
                        translation = translation.replace("\"","");
                        if (y==0)
                        {
                            text.append( QString( translation + ": ") );
                        } else {
                            text.append( QString( "\t" + translation + "\n" ) );
                        }
                    }
                    text.append( "\n" );
                }
                j++;
            }
        }
    }

    kDebug("All operations done. Setting text to textarea.");
  
//-----EMIT THE SIGNAL!! DONT FORGET!!!
emit translated(text);
   

 kDebug("Done.");
   

}