#include "kidenticon.h"

#include <QGraphicsGridLayout>
#include <QPainter>
#include <QFontMetrics>
#include <QSizeF>
#include <QLabel>
#include <QUuid>
#include <KLocale>
#include <KIcon>

#include <plasma/svg.h>
#include <plasma/theme.h>
#include <plasma/widgets/iconwidget.h>

#include "kidenticongenerator.h"

kidenticon::kidenticon(QObject *parent, const QVariantList &args)
    : Plasma::Applet(parent, args)
{
    // this will get us the standard applet background, for free!
    setBackgroundHints(DefaultBackground);
    setHasConfigurationInterface(true);
    resize(200, 200);
}


kidenticon::~kidenticon()
{
    if (hasFailedToLaunch()) {
        // Do some cleanup here
    } else {
        // Save settings
    }
}

void kidenticon::init()
{
    QGraphicsGridLayout * layout = new QGraphicsGridLayout(this);
    setLayout(layout);

    Plasma::IconWidget * icon;

    for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 6; j++) {
            icon = new Plasma::IconWidget(this);
            icon->setIcon(KIdenticonGenerator::self()->generate(64, QUuid::createUuid()));
            layout->addItem(icon, i, j);

            if (j == 5) {
                icon->setEnabled(false);
            }
        }
    }
}

#include "kidenticon.moc"
