/*
 *   Copyright 2008 Aike J Sommer <dev@aikesommer.name>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2,
 *   or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#ifndef OUTPUTSERVICE_H
#define OUTPUTSERVICE_H

#include <Plasma/Service>
#include <Plasma/ServiceJob>


namespace Kephal {
    class Output;
}


class OutputService : public Plasma::Service {
    Q_OBJECT
    
    public:
        OutputService(QObject * parent, Kephal::Output * output);
        
    protected:
        Plasma::ServiceJob * createJob(const QString & operation, QMap<QString,QVariant> & parameters);

    private:
        Kephal::Output * m_output;
};


class OutputServiceJob : public Plasma::ServiceJob {
    Q_OBJECT

    public:
        OutputServiceJob(Kephal::Output * output, const QString & operation,
                QMap<QString,QVariant> & parameters, QObject* parent = 0);

        void start();

    private:
        Kephal::Output * m_output;
};

#endif // OUTPUTSERVICE_H
