/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "krossappletscript.h"
#include <plasma/applet.h>
#include <KDebug>

KrossAppletScript::KrossAppletScript(QObject* parent,
                                     const QVariantList &args,
                                     const QString &language)
    : Plasma::AppletScript(parent), m_language(language)
{
    Q_UNUSED(args)
}

KrossAppletScript::~KrossAppletScript()
{
}
void KrossAppletScript::setContentSize(int width, int height)
{
    if (applet()) {
        applet()->setContentSize(width, height);
    }
}

bool KrossAppletScript::init()
{
    QString name;
    if (applet() && !mainScript().isEmpty()) {
        m_plasma.setApplet(applet());
        if (initScript(this, m_language, mainScript(), "applet",
                       &m_plasma, "plasma")) {
            callFunction("initScript");
            return true;
        }
    }
    kDebug() << "Could not init script" << m_language << name;
    return false;
}

void KrossAppletScript::paintInterface(QPainter* painter,
                                       const QStyleOptionGraphicsItem* option,
                                       const QRect &contentsRect)
{
    callFunction("paintInterface", QVariantList() << (qulonglong)painter <<
                                        (qulonglong)option << contentsRect);
}

#include "krossappletscript.moc"
