/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KROSSAPPLETSCRIPT_H
#define KROSSAPPLETSCRIPT_H

#include "plasmascript.h"
#include <kross.h>
#include <plasma/scripting/appletscript.h>

class KDE_EXPORT KrossAppletScript : public Plasma::AppletScript, KrossScriptEngine
{
    Q_OBJECT
public:
    KrossAppletScript(QObject* parent, const QVariantList &args,
                      const QString &language);
    ~KrossAppletScript();

    virtual bool init();
    virtual void paintInterface(QPainter* painter,
                                const QStyleOptionGraphicsItem* option,
                                const QRect &contentsRect);

public slots:
    void setContentSize(int width, int height);

private:
    QString m_language;
    PlasmaScript m_plasma;
};

#endif // KROSSAPPLETSCRIPT_H

