/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KROSSDATAENGINESCRIPT_H
#define KROSSDATAENGINESCRIPT_H

#include <kross.h>
#include <plasma/scripting/dataenginescript.h>

class KDE_EXPORT KrossDataEngineScript : public Plasma::DataEngineScript, KrossScriptEngine
{
    Q_OBJECT
public:
    KrossDataEngineScript(QObject* parent, const QVariantList &args,
                          const QString &language);
    ~KrossDataEngineScript();

    virtual bool init();
    virtual bool sourceRequestEvent(const QString& name);
    virtual bool updateSourceEvent(const QString& source);

public slots:
    void setData(const QString& source, const QString& key,
                 const QVariant& value);
    void setData(const QString &source, const QVariant &value);
    void removeAllData(const QString& source);
    void removeData(const QString& source, const QString& key);
    void setMinimumPollingInterval(int minimumMs);
    int  minimumPollingInterval() const;
    void setPollingInterval(uint frequency);
    void removeAllSources();

private:
    QString m_language;
};

#endif // KROSSDATAENGINESCRIPT_H

