/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATDEFINES_H
#define KORATDEFINES_H

#include <QList>

namespace Korat
{
//const qreal LARGEST_WIDTH = 96;
const qreal LARGEST_HEIGHT = 96;
const qreal SMALLEST_HEIGHT = LARGEST_HEIGHT/3.0;
const qreal SMALLEST_ICON_SIZE = 22;
const qreal LARGEST_ICON_SIZE = 64;

typedef QList<int> WeightList;

enum Corner {
    TopLeft,
    TopRight,
    BottomLeft,
    BottomRight
};

enum Edge {
    Left,
    Top,
    Right,
    Bottom
};

enum LayoutWeight {
    // item level
    ItemMiniBar = 40,

    // box level
    BoxButtonSmall = 40,
    BoxButtonSmallWithText = 80,
    BoxButtonLarge = 120,
    BoxMiniBarThreeRow = 40,
    BoxMiniBarTwoRow = 80,
    BoxMiniBarOneRow = 130,
    BoxGalleryIconOnly = 40,
    BoxGallerySmall = 60,
    BoxGalleryMedium = 80,
    BoxGalleryLarge = 120,
    BoxGalleryHugeBase = 160,

    // group level
    GroupIcon = 10,
    GroupNormal = 20
};

} // namespace Korat

#endif // KORATDEFINES_H
