#ifndef KORATMINIBARGROUP_H
#define KORATMINIBARGROUP_H

#include "koratbar_export.h"
#include "koratitem.h"
#include "koratminibar.h"

namespace Korat
{
class MiniBarGroupPrivate;
class KORATBAR_EXPORT MiniBarGroup : public Item
{
    Q_OBJECT
public:
    MiniBarGroup(QGraphicsItem *parent=0);
    virtual ~MiniBarGroup();

    void addMiniBar(MiniBar *minibar);
    void removeMiniBar(int index);
    void removeMiniBar(MiniBar *minibar);
    MiniBar *getMinibar(int index);

    virtual QList<WeightList> availableWidths();
    virtual qreal getWidth(const WeightList &);
    virtual void adjustWidth(const WeightList &);

    void setLargestSizeMode(LayoutWeight mode);
    void setMinimumSizeMode(LayoutWeight mode);
    void setFixedSizeMode(LayoutWeight mode);

Q_SIGNALS:
    void sizeChanged();

private:
    friend class MiniBarGroupPrivate;
    MiniBarGroupPrivate *d;
    Q_PRIVATE_SLOT(d, void sizeUpdate())
};

} // namespace Korat

#endif // KORATMINIBARGROUP_H
