/****************************************************************************
**
** Copyright (C) 2006-$THISYEAR$ $TROLLTECH$. All rights reserved.
**
** This file is part of the $MODULE$ of the Qt Toolkit.
**
** $TROLLTECH_DUAL_LICENSE$
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef EDGE_H
#define EDGE_H

#include "edgesource.h"
#include <QGraphicsItem>

class NodeItem;

class Edge : public QGraphicsItem
{
public:
    Edge();
    ~Edge();

    QPointF start() const;
    QPointF end() const;

    NodeItem *sourceNode() const;
    void setSource(NodeItem *node,
                   const QString &property);

    NodeItem *destNode() const;
    void setDest(NodeItem *node,
                 const QString &property);

    void adjust();
    void adjust(const QPointF &source, const QPointF &dest);

    enum { Type = UserType + 2 };
    int type() const { return Type; }

    bool updateLink();

protected:
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
private:
    NodeItem  *source, *dest;
    QString   sourceProp, destProp;
    QRectF    sourceRect;
    QRectF    destRect;

    QPointF sourcePoint;
    QPointF destPoint;

    QPainterPath m_path;
};

#endif
