#ifndef WIDGET_H
#define WIDGET_H

#include <QGLWidget>
#include <QString>
#include <QPointF>

#include "composition.h"


class Widget : public QGLWidget
{
    Q_OBJECT
public:
    Widget(QWidget *parent=0);

    void setComposition(Quasar::Composition *compo);
    Quasar::Composition *composition() const;

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);

private:
    QPointF m_point;
    Quasar::Composition *m_compo;
    bool m_compoInited;
};

#endif
