#include "widget.h"

#include "node.h"

#include <QtGui>

Widget::Widget()
    : ParentWidget(),
      compo(this)
{
    Quasar::Node *input = compo.createNode("/input/file");
    input->setPropertyValue("inputFile", "sample.jpg");

    Quasar::Node *mouse = compo.createNode("/input/mouse");
    Quasar::Node *output = compo.createNode("/output/render");
    Quasar::Node *filter = compo.createNode("/blur/exponential");

    Quasar::link(input, "layer", filter, "input");
    Quasar::link(filter, "output", output, "layer");
    Quasar::link(mouse, "position", output, "position");
}

QSize Widget::sizeHint() const
{
    return QSize(640, 480);
}

void Widget::paintEvent(QPaintEvent *)
{
    QPainter p(this);
    compo.render(&p);
    QTimer::singleShot(1000/30, this, SLOT(update()));
}
