#ifndef QUASAR_EDGEDETECTION_P_H
#define QUASAR_EDGEDETECTION_P_H

#include "filternode.h"
#include <GL/gl.h>

namespace Quasar
{
    class EdgeDetectionNode : public FilterNode
    {
        Q_OBJECT
    public:
        EdgeDetectionNode();

        virtual QRectF domainOfDefinition(const QRectF &rect) const;
        virtual QRectF regionOfInterest(const QRectF &rect) const;

        virtual void aboutToExecute();
    protected:
        void programChanged(GLuint prog);
        void propertyChanged(const QString &name, const QVariant &val);
    private:
        GLuint m_deltaXLoc;
        GLuint m_deltaYLoc;
        GLuint m_thresholdLoc;
    };
}


#endif
