/*  This file is part of the KDE project
    Copyright (C) 2008 Matthias Kretz <kretz@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) version 3.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef QUASAR_PHONONINPUTNODE_P_H
#define QUASAR_PHONONINPUTNODE_P_H

#include "phononinputnode.h"
#include <texture.h>
#include <GL/gl.h>
#include <QtCore/QMutex>
#include <QtCore/QWaitCondition>

class QGLFramebufferObject;

namespace Quasar
{

class PhononInputNodePrivate
{
    Q_DECLARE_PUBLIC(PhononInputNode)
    protected:
        PhononInputNodePrivate();
        PhononInputNode *q_ptr;
        Texture texture;
        Phonon::Experimental::VideoFrame2 frameToProcess;
        Phonon::Experimental::VideoFrame2::Format currentFormat;
        QMutex mutex;
        QWaitCondition wait;

        GLuint fragShader;
        GLuint program;
        GLuint oneOverFrameWidthParameter;
        QGLFramebufferObject *fbo;

        void loadProgram();
        void checkFormat(Phonon::Experimental::VideoFrame2::Format f);
};

} // namespace Quasar

#endif // QUASAR_PHONONINPUTNODE_P_H
