/*
    This file is part of the KDE project.
    Copyright (c) 2005 Friedrich W. H. Kossebau <Friedrich.W.H@Kossebau.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License version 2 as published by the Free Software Foundation.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301  USA
*/


// qt specific
#include <qtooltip.h>
#include <qpainter.h>
#include <qstyle.h>
// kde specific
#include <kdebug.h>
#include <kicontheme.h>
// applet specific
#include "kuserface.h"
#include "ksessionmenu.h"
#include "ksessionbutton.h"
#include "ksessionbutton.moc"



KSessionButton::KSessionButton( QWidget* Parent, const char* Name )
: QButton( Parent, Name ), Myself(), FaceSize( 0 )
{
  loadFace();

  int Style = ShowFaceBefore | FirstFullName | TwoRows;

  QToolTip::add( this, KUserRichTexter::self()->createUserDesc(Myself,Style) );

  Menu = new KSessionMenu( this );

  connect( this, SIGNAL(pressed()), SLOT(showMenu()) );
}



void KSessionButton::loadFace()
{
/*    KIconLoader *IconLoader = KGlobal::iconLoader();
    QString nm = m_iconName;

    NormalFace =   KUserFaceLoader->loadIcon(Myself, FaceSize, KIcon::DefaultState, 0, true);
    HighlightFace = KUserFaceLoader->loadIcon(Myself, FaceSize, KIcon::ActiveState, 0, true);*/
    NormalFace = KUserFaceLoader::self()->loadFaceIcon(Myself,KIcon::Panel, FaceSize, KIcon::DefaultState);
    HighlightFace = KUserFaceLoader::self()->loadFaceIcon(Myself,KIcon::Panel, FaceSize, KIcon::ActiveState);
    setPixmap( NormalFace );
    Highlighted = false;
}
