/*
    This file is part of the KDE project.
    Copyright (c) 2005 Friedrich W. H. Kossebau <Friedrich.W.H@Kossebau.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License version 2 as published by the Free Software Foundation.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301  USA
*/

#ifndef SESSIONAPPLET_H
#define SESSIONAPPLET_H

// qt specific
#include <qevent.h>
#include <qstring.h>
// kde specific
#include <kpanelapplet.h>
// applet specific
#include "klocalsessionmanager.h"


class MenuButton;

class SessionApplet : public KPanelApplet
{
    Q_OBJECT
public:
  static const char * const AppletName;

public:
    SessionApplet( const QString& ConfigFile, QWidget *Parent, const char *Name );
    ~SessionApplet();

protected: // KPanelApplet API
    virtual int widthForHeight( int Height) const;
    virtual int heightForWidth( int Width ) const;
    virtual void about();
    virtual void preferences();
    virtual void loadConfig();
    virtual void saveConfig();
    virtual void positionChange( Position P );

protected: // QWidget API
    virtual void resizeEvent( QResizeEvent * );
    virtual void mousePressEvent( QMouseEvent *ME );

private slots:
    void slotLockPrefs();
    void slotLogoutPrefs();

private:
    MenuButton *Button;
    KLocalSessionManager SessionManager;
};

#endif
