/* This file is part of Strigi Desktop Search
 *
 * Copyright (C) 2006 Jos van den Oever <jos@vandenoever.info>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#ifndef _strigi_H_
#define _strigi_H_

#include <kurl.h>
#include <kio/slavebase.h>
#include <kio/job.h>
#include <strigi/strigihtmlgui.h>

class QByteArray;
class KFileItem;

class kio_strigiProtocol : public QObject, public KIO::SlaveBase
{
Q_OBJECT
private:
    class Helper;
    Helper* helper;
    StrigiHtmlGui htmlgui;
    QByteArray icondata;
    int dataSent;

    void getIcon(const QString& file);
private slots:
    void slotData(KIO::Job *job, const QByteArray &data);
    void jobFinished( KIO::Job* job );
    void slotPreview (const KFileItem *item, const QPixmap &preview);
public:
    kio_strigiProtocol(const QByteArray &protocol, const QByteArray &pool_socket, const QByteArray &app_socket);
    virtual ~kio_strigiProtocol();
    virtual void mimetype(const KUrl& url);
    virtual void get(const KUrl& url);
    virtual void listDir ( const KUrl& url );
};

#endif
